<?php

declare(strict_types=1);

namespace FiloBlu\RuleDayFromBirthday\Plugin\Rule;

use Magento\SalesRule\Api\Data\RuleExtensionFactory;
use Magento\SalesRule\Api\Data\RuleExtensionInterface;
use Magento\SalesRule\Api\Data\RuleInterface;
use Magento\SalesRule\Api\RuleRepositoryInterface;

/**
 * @class RuleRepositoryPlugin
 * @package FiloBlu\RuleDayFromBirthday\Plugin
 */
class RuleRepositoryPlugin
{

    /**
     * @var RuleExtensionFactory
     */
    protected $extensionFactory;

    /**
     * @param RuleExtensionFactory $extensionFactory
     */
    public function __construct(RuleExtensionFactory $extensionFactory)
    {
        $this->extensionFactory = $extensionFactory;
    }

    /**
     * @param RuleRepositoryInterface $subject
     * @param RuleInterface $entity
     * @return RuleInterface
     * @see RuleRepositoryInterface::save()
     */
    public function beforeSave(
        RuleRepositoryInterface $subject,
        RuleInterface           $entity
    ): RuleInterface
    {
        $rule = $entity;
        /** Get Current Extension Attributes from Rule
         * @var RuleExtensionInterface|null
         */
    /*$extensionAttributes = $rule->getExtensionAttributes();
    $extensionAttributes = $extensionAttributes ? $extensionAttributes : $this->extensionFactory->create();
    $applyOnWeekday = $extensionAttributes->getApplyOnWeekday();

    if ($applyOnWeekday != null) {
        if (is_array($applyOnWeekday)) {
            $applyOnWeekday = implode(',', $applyOnWeekday);
        }

        $rule->setData('apply_on_weekday', $applyOnWeekday);
    }*/

        return [$rule];
    }
}

